;;;; crib-line.el -- part of John's elisp change-ringing system
;;; Output crib-sheets for single leads of methods
;;; Time-stamp: <98/01/13 14:33:21 john>

(provide 'crib-line)
(require 'beer)

(defun ringing:crib-line-display-function (row
				   remaining-changes
				   method-holder
				   rounds
				   place-bell)
  "Output this ROW to stdout."
  (let ((i 1)
	(n (length row)))
    (while (< i n)
      (let ((bellchar (aref row i)))
      (princ (cond
	      ((= bellchar place-bell) "*")
	      ((= bellchar ?*) "*")
	      ((= bellchar ?1) ".")
	      ((= bellchar ?.) ".")
	      (t " ")))
      (incf i)))
    (princ "\n")))

(defun ringing:crib-line-to-stdout (method place-bell)
  "Output to stdout a crib for METHOD for PLACE-BELL."
  (let ((method-data (ringing:find-named-method method))
	(place-marker (list 'work)))
    (princ "\nCrib sheet for place bell ")
    (princ (char-to-string place-bell))
    (princ " of ")
    (princ (ringing:method-name method))
    (princ "\n")
    (ringing:ring-from-rounds-plain method-data
				    'ringing:ring-one-lead-helper-function
				    (list place-marker)
				    'ringing:crib-line-display-function
				    (list place-bell))))

;;; end of crib-line.el

