;;;; dixonoids.el -- part of John's elisp change-ringing system
;;; Handles things like Dixons
;;; Time-stamp: <98/05/12 11:54:27 john>

(defun ringing:dixonoid-plain-course-helper-function (row
						      remaining-changes
						      method-holder
						      rounds
						      place-marker)
  "Helper function for ringing or showing plain courses of things like Dixons."
  (incf ringing:plain-course-row-count)
  (when t
    (message "In dixonoid helper: row=%s remaining=%s work=%s lead-end=%s\n"
	     row remaining-changes
	     (change-ringing-method-work (car method-holder))
	     (change-ringing-method-plain-lead-end (car method-holder))))
  (let* ((method (car method-holder))
	 (rules (change-ringing-method-autocalls method))
	 (which-rule (catch 'rule-matched
		       (dolist (rule rules)
			 (when (string-match (car rule) row)
			   (throw 'rule-matched (cdr rule))))
		       'no-rule-matched)))
    (message "which-rule=%s\n" which-rule)
    (if (or ringing:backstroke
	    (eq which-rule 'no-rule-matched))
	(if (string= row rounds)
	    nil
	  (if remaining-changes
	      t
	    (let ((method (car method-holder)))
	      (cons row
		    (case (car place-marker)
		      ((lead-end)
		       (message "Lead end\n")
		       (when ringing:lead-end-callback
			 (apply ringing:lead-end-callback
				row
				remaining-changes
				method
				ringing:lead-end-callback-args))

		       (rplaca place-marker 'work)
		       (change-ringing-method-work method))
		      ((work)
		       (message "Work\n")
		       (rplaca place-marker 'lead-end)
		       (change-ringing-method-plain-lead-end method)))))))
      (list (ringing:ring-one-change row (car which-rule))
	    which-rule))))

;;; end of dixonoids.el
