;;;; ermm.el  -- part of John's elisp change-ringing system
;;; Emacs Ringing Multi-Media hacks
;;; Time-stamp: <97/07/07 16:17:09 john>

(eval-when (compile load eval)
  (provide 'ermm)
  (require 'bell-numbers))

(defvar ermm:mini-ropes t
  "Whether to draw mini-ropes.")

(defvar ermm:bell-delay .2
  "How long to wait between bells.")

(defvar ermm:anything-to-do nil
  "Whether there is anything for ermm to do.")

(defun ermm:init (n)
  "Initialize emacs ringing multi-media for N bells, or turn off if N is nil."
  (setq ermm:anything-to-do
	(and (integerp n) (or ermm:mini-ropes)))
  (when ermm:anything-to-do
    (if ermm:mini-ropes
	(progn
	  (require 'mini-ropes)
	  (mini-ropes:init n)))))

(defun ermm:output-row (row)
  "Output ROW in fancy ways, possibly distinguishing ringing:observation if given."
  (if ermm:anything-to-do
      (save-window-excursion
	(let* ((i 1)
	       (n (length row))
	       (bell (ringing:bell-char-to-number (aref row i))))
	  (while (and (< i n)
		      bell)
	    (if ermm:mini-ropes (mini-ropes:ring bell))
	    (sit-for ermm:bell-delay)
	    (incf i)
	    (setq bell (ringing:bell-char-to-number (aref row i))))))))

;;; end of ermm.el
